"""
Pandaren Brewmaser made by Freddukes
"""
import es, gamethread, wcs, random
from wcs import wcs

RaceName = 'Pandaren Brewmaster'
race = wcs.Race(RaceName)

race.registerSkill('Breath of Fire',5,2,'Cause initial damage, followed by burn damage.')
race.registerSkill('Drunken Haze',6,2,'Your victims speed decreases')
race.registerSkill('Drunken Brawler',5,3,'Have a chance to dodge enemy attacks, and deal more damage.')
race.registerUltimate('Storm, Earth and Fire',8,8,4,'Turn into Fire, Earth or Storm!')
race.registerMinLevel(30)
race.registerTeamLimit(3)

def load():
	es.ServerVar('eventscripts_noisy').set(int(es.ServerVar('eventscripts_noisy')+1))

def unload():
	es.ServerVar('eventscripts_noisy').set(int(es.ServerVar('eventscripts_noisy')-1))

def player_spawn(ev):
	userid = ev['userid']
	sef = wcs.GetLevel(userid,RaceName,'Storm, Earth and Fire')
	if sef:
		wcs.Command(userid).UpdateDict('Brew_Element','')
		wcs.Command(userid).UpdateDict('Brew_Counter',0)
		
def player_death(ev):
	if wcs.GetLevel(ev['userid'],RaceName,'Storm, Earth and Fire'):
			if wcs.Command(ev['userid']).ReturnDict('Brew_Counter'):
				TransformBack(ev['userid'])
		
def player_hurt(ev):
	userid = ev['userid']
	attacker = ev['attacker']
	if not int(ev['es_userdead']):
		dblevelu = wcs.GetLevel(userid,RaceName,'Drunken Brawler')
		dblevela = wcs.GetLevel(attacker,RaceName,'Drunken Brawler')
		dhlevel = wcs.GetLevel(attacker,RaceName,'Drunken Haze')
		boflevel = wcs.GetLevel(attacker,RaceName,'Breath of Fire')
		if dblevelu and (random.randint(1,20) <= dblevelu):
			wcs.Command(userid).Heal(int(ev['dmg_health']))
			es.tell(userid,'#multi','#lightgreenDrunken Brawler #default- #greenYou dodged your enemies attack')
		if dblevela and int(ev['dmg_health']) > 20 and (random.randint(1,20) <= dblevela):
			wcs.Command(userid).Damage((int(ev['dmg_health']) * dblevela * 0.1), 32, attacker)
			es.tell(attacker,'#multi','#lightgreenDrunken Brawler #default- #greenYou dealt extra damage against your victim.')
		if dhlevel and (random.randint(1,20) <= dhlevel):
			wcs.Command(userid).SpeedAdd(dhlevel * -0.05)
			gamethread.delayed(dhlevel * 0.5,NormalSpeed, (userid, attacker, dhlevel))
			es.tell(attacker,'#multi','#lightgreenDrunken Haze #default- #greenYou just slowed your enemy')
		if boflevel and (random.randint(1,20) <= boflevel):
			wcs.Command(userid).Burn(boflevel)
			es.tell(attacker,'#multi','#lightgreenBreath of Fire #default- #greenYou just set your enemy on fire!')
		
def player_footstep(ev):
	userid = ev['userid']
	if wcs.GetLevel(userid,RaceName, 'Storm, Earth and Fire') and wcs.Command(userid).ReturnDict('Brew_Element'):
		element = wcs.Command(userid).ReturnDict('Brew_Element')
		level = wcs.GetLevel(userid,RaceName,'Storm, Earth and Fire')
		filt = '%s'%('#t' if int(es.getplayerteam(userid)) == 3 else '#ct')
		if element == 'Fire':
			wcs.Effect().Follow(userid,255,0,0)
			wcs.Effect().Ring3(userid, random.randint(20,80), random.randint(1,3), 255, 0, 0)
			wcs.Command(userid).Near(level * 50, Burn, filt)
		elif element == 'Storm':
			es.emitsound('player',userid,'player/footsteps/mud%s.wav'%random.randint(1,4),'1.0','0.4')
			wcs.Effect().Ring1(userid, 30, 1, 0, 0, 255)
			gamethread.delayed(1,wcs.Effect().Ring1,(userid, 50, 1, 0, 0, 255))
			wcs.Command(userid).Near(level * 50, Shock, filt)
		elif element == 'Earth':
			es.emitsound('player',userid,'ambient/explosions/explode_%s.wav'%random.choice(['5','8','9']),'1.0','0.0')
			wcs.Effect().Ring2(userid,random.randint(80,100),1,128,128,128) 
			wcs.Command(userid).Near(level * 50, Shake, filt)
			
def Burn(userid, attacker):
	if not wcs.Command(userid).GetWallBetween(attacker): wcs.Command(userid).Burn(5)

def Shock(userid, attacker):
	if not wcs.Command(userid).GetWallBetween(attacker):
		wcs.Command(userid).Freeze(1)
		wcs.Command(userid).Shake(1,3)
		es.emitsound('player',userid,'ambient/energy/zap3.wav','0.5','0.6')
		wcs.Effect().Beam1(attacker,userid,3,random.randint(1,255),0,random.randint(1,255))
	
def Shake(userid, attacker):
	if not wcs.Command(userid).GetWallBetween(attacker):
		wcs.Command(userid).Shake(2,5)
		wcs.Command(userid).Push(0,0,150)
		if random.randint(1,5) <= 1:
			wcs.Command(userid).Drop()
		wcs.Effect().Ring2(userid,100,2,255,255,255)
		
def NormalSpeed(userid,attacker,dhlevel):
	if not int(es.getplayerprop(userid,'CCSPlayer.baseclass.pl.deadflag')):
		wcs.Command(userid).SpeedAdd(dhlevel * 0.05)
		
def player_ultimate_on(ev):
	userid = ev['userid']
	sef = wcs.GetLevel(userid, RaceName, 'Storm, Earth and Fire')
	if sef:
		wcs.Command(userid).UpdateDict('Brew_Element','')
		wcs.Command(userid).UpdateDict('Brew_Counter',0)
		Increment(userid)

def Increment(userid):
	delay_name = 'brew_%s'%userid
	wcs.Command(userid).Freeze(1)
	loop_counter = wcs.Command(userid).ReturnDict('Brew_Counter')
	es.emitsound('player',userid,'buttons/blip2.wav',0.5,0.5)
	wcs.Effect().Ring2(userid,loop_counter * 15, 11-loop_counter, random.randint(1,255),random.randint(1,255),random.randint(1,255))
	if loop_counter < 10:
		es.usermsg("create", "brewcounter", "HintText")
		es.usermsg("write","short","brewcounter",-1)
		format = 'Charging....\n-------------------\n'
		wcs.Command(userid).ModDict('Brew_Counter',1)
		while loop_counter:
			loop_counter -= 1
			format += 'o'
		es.usermsg("write","string","brewcounter",format)
		es.usermsg("send","brewcounter",userid,0)
		es.usermsg("delete","brewcounter")
		gamethread.delayedname(1,delay_name,Increment,userid)
	else:
		es.stopsound(userid,'sound')
		es.cexec(userid,'-ultimate')
		
def player_ultimate_off(ev):
	userid = ev['userid']
	sef = wcs.GetLevel(userid, RaceName, 'Storm, Earth and Fire')
	if sef:
		gamethread.cancelDelayed('brew_%s'%userid)
		if not int(ev['cooldown']):
			looped = wcs.Command(userid).ReturnDict('Brew_Counter')
			if looped < 10:
				wcs.Command(userid).SetCoolDown('Storm, Earth and Fire',looped)
			else:
				wcs.Command(userid).SetCoolDown('Storm, Earth and Fire',45)
				element = random.choice(['Storm','Earth','Fire'])
				wcs.Command(userid).UpdateDict('Brew_Element',element)
				if element == 'Storm':
					alpha = wcs.Command(userid).ReturnDict('Alpha')
					wcs.Command(userid).Color('grey',alpha=alpha/2.0)
					wcs.Command(userid).ChangeGravity(-0.3)
					wcs.Command(userid).SpeedAdd(0.3)
					AtmosphereStorm(userid)
				elif element == 'Earth':
					wcs.Command(userid).Color('brown')
					wcs.Command(userid).ChangeGravity(0.3)
					wcs.Command(userid).SpeedAdd(-0.3)
					wcs.Command(userid).HealthAdd(100)
				else:
					wcs.Command(userid).Color('red')
					es.emitsound('player',userid,'ambient/fire/mtov_flame2.wav','1.0','0.0')
				es.tell(userid,'#multi','#greenYou have transformed into #default%s#green!'%element)
				wcs.Command(userid).UpdateDict('Brew_Counter',sef * 4)
				gamethread.delayedname(1,'decrement_%s'%userid,Decrement,userid)
			
def AtmosphereStorm(userid):
	es.emitsound('player',userid,'ambient/atmosphere/thunder%s.wav'%random.randint(1,4),'1.0','0.0')
	gamethread.delayedname(4,'sfx_%s'%userid, AtmosphereStorm, userid)

def round_end(ev):
	for a in es.getUseridList():
		if wcs.GetLevel(a,RaceName,'Storm, Earth and Fire'):
			if wcs.Command(a).ReturnDict('Brew_Counter'):
				TransformBack(a)
			
def Decrement(userid):
	current_loop = wcs.Command(userid).ReturnDict('Brew_Counter')
	if current_loop:
		es.usermsg("create", "brewcounter", "HintText")
		es.usermsg("write","short","brewcounter",-1)
		es.usermsg("write","string","brewcounter",'Time left as %s:\n---------------------\n%s Seconds'%(wcs.Command(userid).ReturnDict('Brew_Element'),current_loop))
		es.usermsg("send","brewcounter",userid,0)
		es.usermsg("delete","brewcounter")
		wcs.Command(userid).ModDict('Brew_Counter',-1)
		gamethread.delayedname(1,'decrement_%s'%userid,Decrement,userid)
	else:
		TransformBack(userid)
		
def TransformBack(userid):
	gamethread.cancelDelayed('decrement_%s'%userid)
	gamethread.cancelDelayed('sfx_%s'%userid)
	a = wcs.Command(userid)
	a.UpdateDict('Brew_Element','')
	a.UpdateDict('Brew_Counter',0)
	a.Color()
	a.Health(100)
	a.SetGravity(1.0)
	a.Speed(1.0)
	es.tell(userid,'#multi','#lightgreenYou have transformed back into your human state.')
